; Xe[WU

EN_ST6_CHAPTER		.equ	0
EN_ST6_SPIRIT_A		.equ	1
EN_ST6_SPIRIT_B		.equ	2
EN_ST6_SPIRIT_C		.equ	3
EN_ST6_SPIRIT_D		.equ	4
EN_ST6_SPIRIT_E		.equ	5
EN_ST6_AGGFAIRY_A	.equ	6
EN_ST6_AGGFAIRY_B	.equ	7
EN_ST6_YOUMU_A		.equ	8
EN_ST6_YOUMU_B		.equ	9
EN_ST6_YOUMU_C		.equ	10
EN_ST6_YOUMU_H		.equ	11
EN_ST6_YOUMU_J		.equ	12
EN_ST6_YUYUKO_A		.equ	13
EN_ST6_YUYUKO_B		.equ	14
EN_ST6_YUYUKO_I		.equ	15
EN_ST6_YUYUKO_L		.equ	16
EN_ST6_YUYUKO_Q		.equ	17

EN_ST6_SPIRIT_CNT	.equ	(EN_REG+0)
EN_ST6_SPIRIT_POS	.equ	(EN_WORK+24)	; 12*6byte

EN_ST6_YOUMU_SPELL	.equ	(EN_REG+0)
EN_ST6_YOUMU_CNT	.equ	(EN_REG+1)
EN_ST6_YOUMU_X		.equ	(EN_REG+2)
EN_ST6_YOUMU_Y		.equ	(EN_REG+3)
EN_ST6_YOUMU_U		.equ	(EN_REG+4)
EN_ST6_YOUMU_V		.equ	(EN_REG+5)

EN_ST6_YUYUKO_SPELL	.equ	(EN_REG+0)
EN_ST6_SHOT_SYNC	.equ	(EN_REG+1)
EN_ST6_TARGET_X		.equ	(EN_REG+2)
EN_ST6_TARGET_Y		.equ	(EN_REG+3)
EN_ST6_PAL		.equ	(EN_REG+4)
EN_ST6_YUYUKO_SCREEN	.equ	(EN_REG+5)
EN_ST6_YUYUKO_X		.equ	(EN_REG+6)
EN_ST6_YUYUKO_Y		.equ	(EN_REG+7)
EN_ST6_PHASE		.equ	(EN_REG+8)
EN_ST6_BANK		.equ	(EN_REG+10)	; 2bytes

EN_ST6_LASER		.equ	(EN_WORK+0)	; 4*12bytes
EN_ST6_PETAL_X		.equ	(EN_WORK+72)	; 12bytes
EN_ST6_PETAL_Y		.equ	(EN_WORK+84)	; 12bytes

POS_ST6_X_8	.equ	$01
POS_ST6_X_16	.equ	$02
POS_ST6_X_24	.equ	$03
POS_ST6_X_32	.equ	$04
POS_ST6_X_40	.equ	$05
POS_ST6_X_48	.equ	$06
POS_ST6_X_56	.equ	$07
POS_ST6_X_64	.equ	$08
POS_ST6_X_72	.equ	$09
POS_ST6_X_80	.equ	$0a
POS_ST6_X_88	.equ	$0b
POS_ST6_X_96	.equ	$0c
POS_ST6_X_104	.equ	$0d
POS_ST6_X_112	.equ	$0e
POS_ST6_X_120	.equ	$0f
POS_ST6_Y_56	.equ	$00
POS_ST6_Y_64	.equ	$10
POS_ST6_Y_72	.equ	$20
POS_ST6_Y_80	.equ	$30
POS_ST6_Y_88	.equ	$40
POS_ST6_Y_96	.equ	$50
POS_ST6_Y_104	.equ	$60
POS_ST6_Y_112	.equ	$70
POS_ST6_Y_120	.equ	$80
POS_ST6_Y_128	.equ	$90
POS_ST6_Y_136	.equ	$a0
POS_ST6_Y_144	.equ	$b0
POS_ST6_Y_152	.equ	$c0
POS_ST6_Y_160	.equ	$d0
POS_ST6_Y_168	.equ	$e0
POS_ST6_Y_176	.equ	$f0


St6_Data:

; V[PX

St6_EventSeq:
	EV_BANK2	BANK_CHR_ENEMY+1
	EV_BANK3	BANK_CHR_CHAPT+1
	EV_BGM		12
	EV_SET		EVS_SPEED, BSW_4F_M
	EV_NATIVE	.tail
	lda	#0
	sta	<EN_ST6_SPIRIT_CNT
	rts
.tail:

St6_EventSeq1:
	EV_WAIT		10
	EV_ENEMY	EN_ST6_CHAPTER,0
	EV_WAIT		50

	EV_BANK3	BANK_CHR_BOSS+3
	EV_PAL		COL_YOUMU
;	EV_JMP		St6_EventSeq3
;	EV_JMP		St6_EventSeqBoss1
;	EV_JMP		St6_EventSeqSecond
;	EV_JMP		St6_EventSeqBoss2

	EV_SET		EVS_A, $00
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_112
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_112
	EV_WAIT		20

	EV_SET		EVS_A, $03
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_72
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_72
	EV_WAIT		20

	EV_SET		EVS_A, $04
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_96
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_112
	EV_WAIT		16

	EV_SET		EVS_A, $04
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_96
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_112|POS_ST6_Y_112
	EV_WAIT		12

	EV_SET		EVS_A, $01
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_96
	EV_WAIT		2

	EV_SET		EVS_A, $01
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_112|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_80
	EV_WAIT		2

	EV_SET		EVS_A, $01
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_88
	EV_WAIT		2

	EV_SET		EVS_A, $01
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_112|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_72
	EV_WAIT		8

	EV_NATIVE	.tail2
	jsr	St6_EnSpiritOrderA
	jmp	St6_EnSpiritOrderB
.tail2:
;	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_104
;	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_104
;	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_96
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_88
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_104|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_56
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_56
;	EV_WAIT		8
	EV_WAIT		9

	EV_NATIVE	.tail3
	jsr	St6_EnSpiritOrderA
	jmp	St6_EnSpiritOrderB
.tail3:
;	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_56
;	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_56
;	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_88
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_96
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_104|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_104
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_104
;	EV_WAIT		12
	EV_WAIT		13


	EV_NATIVE	.tail4
	jmp	St6_EnSpiritOrderA
.tail4:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_64
	EV_NATIVE	.tail5
	jmp	St6_EnSpiritOrderB
.tail5:
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_32|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_48|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_64|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_80|POS_ST6_Y_80
	EV_WAIT		3

	EV_SET		EVS_A, $04
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_96

	EV_SET		EVS_B, $04
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_64|POS_ST6_Y_72
	EV_WAIT		3

	EV_NATIVE	.tail8
	jmp	St6_EnSpiritOrderA
.tail8:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_88
	EV_NATIVE	.tail9
	jmp	St6_EnSpiritOrderB
.tail9:
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_80|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_64|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_48|POS_ST6_Y_104
	EV_WAIT		8

	EV_NATIVE	.tail10
	jsr	St6_EnSpiritOrderA
	jmp	St6_EnSpiritOrderB
.tail10:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_128
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_40|POS_ST6_Y_128
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_56|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_72|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_64
	EV_WAIT		20

St6_EventSeq2:
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_104_2
	EV_WAIT		20

	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_24_2
	EV_WAIT		19

	EV_SET		EVS_A, $00
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_96_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_64
	EV_WAIT		18

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_32_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		18

	EV_SET		EVS_A, $00
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_104_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_64
	EV_WAIT		18

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_24_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		18

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_96
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_112|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_88
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_88
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_40_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_88_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_80
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_80
	EV_WAIT		20

	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_64_2
	EV_WAIT		19

	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_80
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_56|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_72|POS_ST6_Y_72
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_32_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_96_2
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_64
	EV_WAIT		17

	EV_NATIVE	.tail11
	jsr	St6_EnSpiritOrderA
	jmp	St6_EnSpiritOrderB
.tail11:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_96
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_104|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_112
	EV_WAIT		2

	EV_SET		EVS_A, $04
	EV_SET		EVS_B, $04
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_80|POS_ST6_Y_120
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_56|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_72|POS_ST6_Y_120
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_72|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_56|POS_ST6_Y_120
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_64
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_48|POS_ST6_Y_120
	EV_WAIT		2

	EV_NATIVE	.tail13
	jsr	St6_EnSpiritOrderA
	jmp	St6_EnSpiritOrderB
.tail13:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_40|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_72
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_32|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_80
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_24|POS_ST6_Y_104
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_112|POS_ST6_Y_88
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_16|POS_ST6_Y_96
	EV_WAIT		22

	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_64_2
	EV_WAIT		20
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_40_2
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_88_2
	EV_WAIT		15
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_64_2
	EV_WAIT		6
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_32_2
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_96_2
	EV_WAIT		20

	EV_SET		EVS_A, $00
	EV_SET		EVS_B, $00
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_8|POS_ST6_Y_168
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_120|POS_ST6_Y_168
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_152
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_104|POS_ST6_Y_152
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_136
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_88|POS_ST6_Y_136
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_16|POS_ST6_Y_128
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_112|POS_ST6_Y_128
	EV_WAIT		1
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_112
	EV_ENEMY	EN_ST6_SPIRIT_B, POS_ST6_X_96|POS_ST6_Y_112
	EV_WAIT		1
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_64_2
	EV_WAIT		4
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_48_2
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_80_2

St6_EventSeq3:
	EV_WAIT		42
	EV_ENEMY	EN_ST6_YOUMU_A, POS_126_72
	EV_WAIT		30

	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_24|POS_ST6_Y_56
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_40|POS_ST6_Y_72
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_88
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_64|POS_ST6_Y_104
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_120
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_88|POS_ST6_Y_136
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_104|POS_ST6_Y_152
	EV_WAIT		12

	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_112|POS_ST6_Y_56
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_96|POS_ST6_Y_64
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_64|POS_ST6_Y_80
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_88
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_32|POS_ST6_Y_96
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_16|POS_ST6_Y_104
	EV_WAIT		3
	EV_WAIT		28

	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_72_2
	EV_WAIT		8
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_48_2
	EV_WAIT		6
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_24_2
	EV_WAIT		16
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_56_2
	EV_WAIT		8
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_80_2
	EV_WAIT		6
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_104_2
	EV_WAIT		16

	EV_NATIVE	.tail14
	jmp	St6_EnSpiritOrderA
.tail14:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_56
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_24|POS_ST6_Y_96
	EV_WAIT		2
	EV_NATIVE	.tail15
	jmp	St6_EnSpiritOrderA
.tail15:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_48|POS_ST6_Y_112
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_64|POS_ST6_Y_120
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_112
	EV_WAIT		2
	EV_NATIVE	.tail16
	jmp	St6_EnSpiritOrderA
.tail16:
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_104|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_80|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_YOUMU_A, POS_24_2
	EV_WAIT		20

	EV_SET		EVS_A, $ff
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_80|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_96|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_104|POS_ST6_Y_96
	EV_WAIT		2
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_96|POS_ST6_Y_112
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_96|POS_ST6_Y_104
	EV_WAIT		2
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_80|POS_ST6_Y_128
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_80|POS_ST6_Y_120
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_80|POS_ST6_Y_112
	EV_WAIT		2
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_64|POS_ST6_Y_136
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_64|POS_ST6_Y_128
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_64|POS_ST6_Y_120
	EV_WAIT		2
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_48|POS_ST6_Y_128
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_48|POS_ST6_Y_120
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_48|POS_ST6_Y_112
	EV_WAIT		2
;	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_32|POS_ST6_Y_112
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_32|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_24|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_32|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_48|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_64|POS_ST6_Y_56
	EV_WAIT		16

	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_16_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_112_2
	EV_WAIT		12
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_40_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_88_2
	EV_WAIT		8
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_64_2
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_128
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_128
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_120
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_120
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_112
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_112
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_88
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_88
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_64

	EV_WAIT		60
St6_EventSeqBoss1:
	EV_SETUP	SSF_MODE_NORMAL|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST6_YOUMU_B,POS_96_2
	EV_WAIT_SEM

	EV_TALK		1
	EV_PAL		COL_YOUMU

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 0
	EV_NEXT_STEP	0, EN_ST6_YOUMU_C
	EV_WAIT_SEM

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 1
	EV_NEXT_STEP	0, EN_ST6_YOUMU_C
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 2
	EV_NEXT_STEP	0, EN_ST6_YOUMU_C
	EV_WAIT_SEM

	EV_CHG_EFF	0
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 3
	EV_NEXT_STEP	0, EN_ST6_YOUMU_C
	EV_WAIT_SEM
	EV_SET		EVS_SPEED, BSW_1F_S
	EV_SET		EVS_A, 4
	EV_NEXT_STEP	0, EN_ST6_YOUMU_C
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		8

	EV_SETUP	SSF_CONVERGE_BORDER
	EV_WAIT		2

	EV_WAIT_LAYER0
	EV_TALK		2
	EV_PAL		COL_YOUMU
	EV_NEXT_STEP	0, EN_ST6_YOUMU_J

;St6_EventSeq10:
;	EV_WAIT		64
;	EV_NATIVE	.tail
;	lda	<JOYPAD
;	and	JOY_SHOT
;	beq	.1
;	iny
;	iny
;.1:
;	rts
;.tail:
;	EV_JMP		St6_EventSeq10

St6_EventSeqSecond:
	EV_SET		EVS_E, 0
	EV_WAIT		30

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_104|POS_ST6_Y_72
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_56|POS_ST6_Y_72
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_32|POS_ST6_Y_72
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_48|POS_ST6_Y_80
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_72|POS_ST6_Y_80
	EV_WAIT		3
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_96|POS_ST6_Y_80
	EV_WAIT		20

	EV_CALL0	St6_EventSeqEnemy1
	EV_CALL0	St6_EventSeqEnemy1

	EV_WAIT		8

	EV_SET		EVS_A, $03
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_64_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_16_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_112_2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_24|POS_ST6_Y_80
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_104|POS_ST6_Y_80
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_32|POS_ST6_Y_128
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_96|POS_ST6_Y_128
	EV_WAIT		54

St6_EventSeqBoss2:
	EV_BANK2	BANK_CHR_ENEMY+3
	EV_BANK3	BANK_CHR_BOSS+7
	EV_PAL		COL_YUYUKO
	EV_SETUP	SSF_MODE_NORMAL|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST6_YUYUKO_A,POS_64_2
	EV_WAIT_SEM

	EV_TALK		3
	EV_PAL		COL_YUYUKO
;	---
;	EV_CHG_EFF	3
;	EV_SET		EVS_F, 1
;	EV_JMP		St6_EventSeqBoss3
;	---

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 0
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_NATIVE	.tail1
	lda	#ITEM_B_CHERRY
	sta	SMCL(Shot_ResolveBonusOrCherry+1)
	jmp	St6_Shot_HookPlayerShot
.tail1:

	EV_CHG_EFF	3
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 1
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 2
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 3
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_NATIVE	.tail2
	jmp	St6_Shot_UnhookPlayerShot
.tail2:

	EV_SETUP	SSF_MODE_BOSS|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 4
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_NATIVE	.tail3
	jmp	St6_Shot_HookPlayerShot
.tail3:

	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 5
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_SET		EVS_F, 1
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SET		EVS_A, 6
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_NATIVE	.tail4
	jmp	St6_Shot_UnhookPlayerShot
.tail4:

St6_EventSeqBoss3:
	EV_BGM		0

	EV_SETUP	SSF_MODE_BOSS|SSF_ERASE_ENEMY|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_I
	EV_WAIT_SEM

	EV_WAIT		10

	EV_BGM		16

	EV_SETUP	SSF_MODE_BOSS
	EV_SET		EVS_A, 7
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT
	EV_SET		EVS_A, 8
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_B
	EV_WAIT_SEM
	EV_CLR_LAYER3

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST6_YUYUKO_L
	EV_WAIT_SEM
	EV_WAIT		8
	EV_SETUP	SSF_CONVERGE_BORDER

	EV_WAIT		12

	EV_SET		EVS_A, 0
	EV_NATIVE	.tail1
	lda	#BANK_CHR_END1
	sta	<IRQ_BANK+1
	jmp	St6_Util_CutIn
.tail1:

	EV_WAIT		1

	EV_NATIVE	.tail2
	jmp	St6_Util_CutIn
.tail2:

	EV_WAIT		1

	EV_NATIVE	.tail3
	jmp	St6_Util_CutIn
.tail3:

	EV_SETUP	SSF_MODE_CUTIN

	EV_WAIT		3

	EV_NATIVE	.tail4
	jmp	St6_Util_CutIn
.tail4:

	EV_WAIT		3

	EV_NATIVE	.tail5
	jmp	St6_Util_CutIn
.tail5:

	EV_WAIT		3

	EV_NATIVE	.tail6
	jmp	St6_Util_CutIn
.tail6:

	EV_WAIT		6

	EV_NATIVE	.tail7
	jmp	St6_Util_CutIn
.tail7:

	EV_WAIT		20

	EV_NATIVE	.tail8
	jmp	St6_Util_CutIn
.tail8:

	EV_WAIT		30

	EV_SETUP	SSF_MODE_NORMAL

	EV_WAIT		12
	EV_END

;St6_EventSeqEndless:
;	EV_WAIT		64
;	EV_JMP		St6_EventSeqEndless

St6_EventSeqEnemy1:
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_64_2
	EV_WAIT		12
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_40_2
	EV_ENEMY	EN_ST6_AGGFAIRY_B, POS_88_2
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_144
	EV_WAIT		4
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_104
	EV_WAIT		4
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_112|POS_ST6_Y_64
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_32_2
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_144
	EV_WAIT		4
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_104
	EV_WAIT		4
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_16|POS_ST6_Y_64
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_96_2
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_104|POS_ST6_Y_88
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_24|POS_ST6_Y_120
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_96|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_32|POS_ST6_Y_136
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_144
	EV_WAIT		12

	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_24|POS_ST6_Y_88
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_104|POS_ST6_Y_120
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_32|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_96|POS_ST6_Y_136
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_144
	EV_WAIT		12

	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_64_2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_40|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_64|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		12

	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_64_2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_80|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_64|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_48|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_C, POS_ST6_X_40|POS_ST6_Y_64
	EV_WAIT		20

	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_24|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_104|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_40|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_88|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_56|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_72|POS_ST6_Y_80
	EV_WAIT		20

	EV_SET		EVS_A, $00
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_120|POS_ST6_Y_104
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_8|POS_ST6_Y_96
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_88
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_24_2
	EV_ENEMY	EN_ST6_AGGFAIRY_A, POS_104_2
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_120|POS_ST6_Y_88
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_8|POS_ST6_Y_80
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_40|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_120|POS_ST6_Y_72
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_A, POS_ST6_X_88|POS_ST6_Y_64
	EV_WAIT		2
	EV_ENEMY	EN_ST6_SPIRIT_D, POS_ST6_X_8|POS_ST6_Y_64
	EV_WAIT		20

	EV_RET0

; G֌W


St6_RetireSpirit:
	lda	EN_S,x
	and	#$20
	beq	.1
	lda	EN_Y,x
	sec
	sbc	<PL_Y
	cmp	#$d0
	bcs	.1
	jsr	St6_EnSpiritShot
.1:
	jmp	Enemy_Normal_Retire

St6_EnSpiritShot:
	lda	EN_S,x
	and	#$0e
	lsr	a
	tay
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jmp	SMCL(Shot_Normal_Create)
.blt_lo:
	.db	LOW(BL(1,Blt6_SpiritA))
	.db	LOW(BL(1,Blt6_SpiritC))
	.db	LOW(BL(1,Blt6_SpiritD))
	.db	LOW(BL(1,Blt6_SpiritF))
.blt_hi:
	.db	HIGH(BL(1,Blt6_SpiritA))
	.db	HIGH(BL(1,Blt6_SpiritC))
	.db	HIGH(BL(1,Blt6_SpiritD))
	.db	HIGH(BL(1,Blt6_SpiritF))

St6_EnSpiritOrderA:
	ldx	#0
	beq	_St6_EnSpiritOrder	; same as jmp
St6_EnSpiritOrderB:
	ldx	#1
_St6_EnSpiritOrder:
	jsr	Rand
	and	#7
	sty	<FNC_WORK
	tay
	lda	.order,y
	sta	<EVS_A,x
	ldy	<FNC_WORK
	rts
.order:
	.db	$02,$02,$04,$04,$04,$04,$08,$08


St6_RetireAggFairy:
	lda	EN_S,x
	and	#$20
	beq	.1
	jsr	St6_EnAggFairyShot
.1:
	jmp	Enemy_Normal_Retire

St6_EnAggFairyShot:
	ldy	#0
	lda	EN_S,x
	and	#$10
	beq	.1
	iny
.1;
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jmp	SMCL(Shot_Normal_Create)
.blt_lo:
	.db	LOW(BL(1,Blt6_AggFairyA))
	.db	LOW(BL(1,Blt6_AggFairyB))
.blt_hi:
	.db	HIGH(BL(1,Blt6_AggFairyA))
	.db	HIGH(BL(1,Blt6_AggFairyB))

; `F[֐

St6_EnChapter:
	tay
	lda	.xpos,y
	sta	EN_X,x
	lda	.ypos,y
	sta	EN_Y,x
	lda	.type,y
	jmp	Enemy_Effect_Create
.type:
	.db	$40,$50
.xpos:
	.db	40,64
.ypos:
	.db	64,64

St6_EnSpiritA:
	lsr	<EVS_A
	jmp	St6_EnSpiritY

St6_EnSpiritB:
	lsr	<EVS_B
	jmp	St6_EnSpiritY

St6_EnSpiritY:
	sta	<FNC_WORK+6
	stx	<FNC_WORK+7
	bcs	.1

	lda	#LOW(.param1)
	ldy	#HIGH(.param1)
	bne	.2
.1:
	lda	#LOW(.param2)
	ldy	#HIGH(.param2)
.2:
	jsr	Enemy_SetParam

	lda	<FNC_WORK+6
	ldx	<FNC_WORK+7
	jmp	St6_EnSpiritX
.param1:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$20,$04,$00	; T,S,LIFE,P
	.db	$00,14		; A,SP
	.db	$02,$00,$00	; VC,IS,IA
.param2:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$22,$04,$00	; T,S,LIFE,P
	.db	$00,14		; A,SP
	.db	$02,$00,$00	; VC,IS,IA

St6_EnSpiritC:
	sta	<FNC_WORK+6
	stx	<FNC_WORK+7

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	<FNC_WORK+6
	ldx	<FNC_WORK+7
	jmp	St6_EnSpiritX
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$25,$04,$00	; T,S,LIFE,P
	.db	$00,14		; A,SP
	.db	$02,$00,$00	; VC,IS,IA

St6_EnSpiritD:
	sta	<FNC_WORK+6
	stx	<FNC_WORK+7

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	<FNC_WORK+6
	ldx	<FNC_WORK+7
	jmp	St6_EnSpiritX
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$17,$04,$00	; T,S,LIFE,P
	.db	$00,14		; A,SP
	.db	$02,$00,$00	; VC,IS,IA

St6_EnSpiritX:
	tay
	and	#$f0
	lsr	a
;	clc
	adc	#56
	sta	EN_Y,x
	lda	Xcn,y
	and	#$f0
	lsr	a
	sta	EN_X,x
	lda	#0
	sta	EN_U,x
	sta	EN_V,x

	ldy	<EN_ST6_SPIRIT_CNT
	bne	.1
	ldy	#12
.1:
	dey
	tya
	sta	<EN_ST6_SPIRIT_CNT
	sta	EN_D,x

	lda	EN_X,x
	sta	EN_ST6_SPIRIT_POS+0,y
	sta	EN_ST6_SPIRIT_POS+24,y
	sta	EN_ST6_SPIRIT_POS+48,y
	lda	EN_Y,x
	sta	EN_ST6_SPIRIT_POS+12,y
	sta	EN_ST6_SPIRIT_POS+36,y
	sta	EN_ST6_SPIRIT_POS+60,y

	lda	EN_S,x
	and	#$10
	bne	.2
	jsr	Rand
.2:
	and	#$07
	tay
	lda	.angle,y
	sta	EN_A,x
	lda	.ia,y
	sta	EN_IA,x

	lda	EN_D,x
	ora	#$40
.3:
	sta	EN_D,x
	lda	#3
	jsr	Enemy_CB_Wait

	ldy	EN_D,x
	lda	Int-16,y
	bpl	.3
	and	#$0f
	sta	EN_D,x

	lda	EN_IA,x
	eor	#$ff
;	cmp	#$80
;	ror	a
	sta	EN_IA,x

	lda	EN_D,x
	ora	#$20
.4:
	sta	EN_D,x
	lda	#3
	jsr	Enemy_CB_Wait

	ldy	EN_D,x
	lda	Int-16,y
	bpl	.4
	and	#$0f
	sta	EN_D,x

	jsr	St6_EnSpiritShot

	lda	#$02
	sta	EN_T,x
	sta	EN_S,x
	and	#$c0
	ora	#$01
	sta	EN_S,x

	lda	#3
	jsr	Enemy_CB_Wait

	lda	#$03
	sta	EN_SP,x
	lda	#$00
	ldy	EN_Y,x
	cpy	#64
	bcc	.5
	tya
;	sec
	sbc	#64
	lsr	a
	ldy	EN_X,x
	cpy	#64
	bcc	.5
	eor	#$ff
	adc	#0
.5:
	sta	EN_A,x
	ldy	EN_SP,x
	jsr	Enemy_SetVelocity

	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.angle:
	.db	$18,$14,$10,$0c,$f4,$f0,$ec,$e8
.ia:
	.db	$f8,$fa,$fc,$fe,$02,$04,$06,$08
.ac_data:
	.db	$03,$03,$00 ; VC,IS,IA

St6_EnAggFairyA:
	tay
	jsr	Enemy_SetPosition
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#32
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	EN_S,x
	eor	#$20
	sta	EN_S,x
	jsr	St6_EnAggFairyShot

	lda	#32
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$03,$22,$0c,$03	; T,S,LIFE,P
	.db	$80,18		; A,SP
	.db	$04,$fe,$00	; VC,IS,IA
.ac_data:
	.db	$02,$02,$00 ; VC,IS,IA

St6_EnAggFairyB:
	tay
	jsr	Enemy_SetPosition
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#24
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	EN_S,x
	eor	#$20
	sta	EN_S,x
	jsr	St6_EnAggFairyShot

	lda	#24
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$03,$32,$0c,$03	; T,S,LIFE,P
	.db	$80,14		; A,SP
	.db	$04,$fe,$00	; VC,IS,IA
.ac_data:
	.db	$02,$02,$00 ; VC,IS,IA

St6_EnYoumuA:
	tay
	jsr	Enemy_SetPosition

	lda	EN_X,x
	cmp	#64
	bcs	.1
	jmp	St6_EnYoumuA2
.1:
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#9
	jsr	Enemy_CB_Wait

	lda	#$fa
	sta	EN_IS,x
	lda	EN_S,x
	eor	#($18^$16)
	sta	EN_S,x

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#LOW(BL(1,Blt6_YoumuA1))
	ldy	#HIGH(BL(1,Blt6_YoumuA1))
	jsr	SMCL(Shot_Normal_Create)

	lda	#1
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	#28
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$19
	sta	EN_S,x

	lda	#$e0
	sta	EN_A,x
	tay
	lda	#36
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$04,$59,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$28,30		; A,SP
	.db	$04,$fd,$00	; VC,IS,IA
.ac_data:
	.db	$02,$fd,$00 ; VC,IS,IA

St6_EnYoumuA2:
	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#9
	jsr	Enemy_CB_Wait

	lda	#$fa
	sta	EN_IS,x
	lda	EN_S,x
	eor	#($18^$16)
	sta	EN_S,x

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#LOW(BL(1,Blt6_YoumuB))
	ldy	#HIGH(BL(1,Blt6_YoumuB))
	jsr	SMCL(Shot_Normal_Create)

	lda	#1
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	lda	#28
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$19
	sta	EN_S,x

	lda	#$10
	sta	EN_A,x
	tay
	lda	#36
	sta	EN_SP,x
	jsr	Enemy_SetVelocity
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration
	jmp	Enemy_ClearCallback
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$04,$58,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$80,20		; A,SP
	.db	$04,$fd,$00	; VC,IS,IA
.ac_data:
	.db	$02,$fd,$00 ; VC,IS,IA

St6_EnYoumuB:
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#1
	sta	<EVS_SEM
	lda	#5
	sta	<EVS_SPELL

	; o

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#40
	jsr	Enemy_CB_Move

	lda	#$40
	sta	EN_S,x
	lda	#$00
	sta	<EVS_SEM
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$45,$5b,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE
	.dw	Enemy_Boss_Reflect

St6_EnYoumuC:
	ldy	<EVS_A
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jmp	Enemy_CB_Indirect
.lo:
	.db	LOW(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuC))
	.db	LOW(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuD))
	.db	LOW(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuE))
	.db	LOW(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuF))
	.db	LOW(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuG))
.hi:
	.db	HIGH(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuC))
	.db	HIGH(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuD))
	.db	HIGH(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuE))
	.db	HIGH(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuF))
	.db	HIGH(ICB(BANK_PRG_STAGE+1, St6a_EnYoumuG))

St6_EnYoumuH:

.1:
	ldy	<EN_ST6_YOUMU_CNT
	lda	.angle,y
	sta	EN_A,x
	dey
	bpl	.2
	ldy	#11
.2:
	sty	<EN_ST6_YOUMU_CNT

	lda	#LOW(BL(1,Blt6_YoumuD))
	ldy	#HIGH(BL(1,Blt6_YoumuD))
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#6
	jsr	Enemy_CB_Wait

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	beq	.1

	lda	#$ff
	sta	EN_X,x
	rts
.angle:
	.db	$9a, $8e, $82, $76, $6a, $5e
	.db	$66, $72, $7f, $8a, $96, $a2

St6_EnYoumuI:

.1:
	jsr	Rand
	and	#$7f
	sta	EN_X,x

	lda	#LOW(BL(1,Blt6_YoumuH))
	ldy	#HIGH(BL(1,Blt6_YoumuH))
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#6
	jsr	Enemy_CB_Wait

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	beq	.1

	lda	#$ff
	sta	EN_X,x
	rts

St6_EnYoumuJ:
	lda	#1
	sta	<EVS_SEM

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

.away:
	; ޏ
	lda	#$d0
	sta	EN_A,x
	tay
	lda	#21
	sta	EN_SP,x
	jmp	Enemy_SetVelocity
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$58,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE

St6_EnYuyukoA:
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#1
	sta	<EVS_SEM
	lda	#9
	sta	<EVS_SPELL

	; o

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#40
	jsr	Enemy_CB_Move

	lda	#$40
	sta	EN_S,x
	lda	#$00
	sta	<EVS_SEM
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$47,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE
	.dw	Enemy_Boss_Reflect

St6_EnYuyukoB:
	ldy	<EVS_A
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jmp	Enemy_CB_Indirect
.lo:
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoB))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoC))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoD))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoE))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoF))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoG))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoH))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoJ))
	.db	LOW(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoK))
.hi:
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoB))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoC))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoD))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoE))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoF))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoG))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoH))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoJ))
	.db	HIGH(ICB(BANK_PRG_STAGE+2, St6b_EnYuyukoK))

St6_EnYuyukoI:
	lda	#1
	sta	<EVS_SEM

	; ]|

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	EN_X,x
	cmp	#64
	lda	EN_S,x
	adc	#0
	sta	EN_S,x

	jsr	SMCL(Enemy_CB_SetEntry)
	lda	#64
	ldy	#4
	jsr	Enemy_CB_FastMove

	lda	#SE_EN_DOWN
	sta	<SND_SE

	lda	#4
	jsr	Enemy_CB_Wait

	lda	#$4a
	sta	EN_S,x

	jsr	Enemy_ClearVelocity
	lda	#$80
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration

	lda	#14
	jsr	Enemy_CB_Wait

	lda	#SE_EN_DOWN
	sta	<SND_SE

	jsr	Enemy_ClearVelocity
	jsr	Enemy_ClearAcceleration

	lda	#4
	jsr	Enemy_CB_Wait

	lda	#$80
	sta	EN_A,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#SE_EN_DOWN
	sta	<SND_SE

	jsr	Enemy_ClearVelocity
	jsr	Enemy_ClearAcceleration

	lda	#30
	jsr	Enemy_CB_Wait

	ldy	#1
	lda	#EN_ST6_CHAPTER
	jsr	Enemy_Normal_Create
	ldx	<EN_FNC

	lda	#30
	jsr	Enemy_CB_Wait

	lda	#0
	sta	<EVS_F

	lda	#30
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	<EVS_SEM
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$47,$48,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00ff		; BOSS_LIFE
.ac_data:
	.db	$02,$03,$00
;	 0.0 0.0
;	 0.0 0.0
;	 0.5 0.5
;	 1.0 0.5
;	 2.0 1.0
;	 3.0 1.0
;	 4.5 1.5
;	 6.0 1.5
;	 8.0 2.0
;	10.0 2.0
;	12.5 2.5
;	15.0 2.5
;	18.0 3.0
;	21.0 3.0
;	24.5 3.5

St6_EnYuyukoL:
	lda	#1
	sta	<EVS_SEM

	; ]|

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#4
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_A,x
	lda	#$12
	sta	EN_SP,x
	lda	#LOW(.ac_data)
	ldy	#HIGH(.ac_data)
	jsr	Enemy_SetAcceleration

	lda	#12
	jsr	Enemy_CB_Wait

	lda	#$80
	sta	EN_A,x
	lda	#$03
	sta	EN_IS,x

	lda	#$4a
	sta	EN_S,x

	lda	#6
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearVelocity
	jsr	Enemy_ClearAcceleration

	lda	#$00
	sta	<EVS_SEM
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$47,$48,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00ff		; BOSS_LIFE
.ac_data:
	.db	$02,$fd,$00


St6_EnYuyukoQ:

.1:
	lda	<PL_X
	sta	<EN_ST6_TARGET_X
	lda	<PL_Y
	sta	<EN_ST6_TARGET_Y

	lda	#LOW(BL(1,Blt6_YuyukoE1))
	ldy	#HIGH(BL(1,Blt6_YuyukoE1))
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#40
	jsr	Enemy_CB_Wait

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	bne	.9
.2:
	lda	#0
	sta	<EN_ST6_SHOT_SYNC

	lda	#2
	jsr	Enemy_CB_Wait

	lda	<EN_ST6_SHOT_SYNC
	bne	.2

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	bne	.9

	lda	<EN_ST6_TARGET_X
	sta	EN_X,x
	lda	<EN_ST6_TARGET_Y
	sta	EN_Y,x

	lda	#LOW(BL(1,Blt6_YuyukoE2))
	ldy	#HIGH(BL(1,Blt6_YuyukoE2))
	jsr	SMCL(Shot_Normal_Create)

	lda	#30
	jsr	Enemy_CB_Wait

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	beq	.1
.9:
	lda	#$ff
	sta	EN_X,x
	rts

St6_EnYuyukoR:
	lda	#2
	sta	<EVS_B
	lda	#6
	sta	<EVS_C

	lda	#LOW(BL(1,Blt6_YuyukoF1))
	ldy	#HIGH(BL(1,Blt6_YuyukoF1))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lda	#3
	jsr	Enemy_CB_Wait

	lda	#LOW(BL(1,Blt6_YuyukoF5))
	ldy	#HIGH(BL(1,Blt6_YuyukoF5))
	jsr	SMCL(Shot_Normal_Create)

	lda	#3
	jsr	Enemy_CB_Wait

	ldy	<EN_BOSS_INX
	lda	EN_X,y
	sta	EN_X,x
	lda	EN_Y,y
	sta	EN_Y,x

	ldy	<EVS_B
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	dec	<EVS_C
	bne	.3
	lda	#6
	sta	<EVS_C

	lda	#LOW(BL(1,Blt6_YuyukoF1))
	ldy	#HIGH(BL(1,Blt6_YuyukoF1))
	jsr	SMCL(Shot_Normal_Create)

	lda	<EVS_B
	and	#$01
	eor	#$01
	sta	<EVS_B
.3:
	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	beq	.1
.9:
	lda	#$ff
	sta	EN_X,x
	rts
.lo:
	.db	LOW(BL(1,Blt6_YuyukoF4))
	.db	LOW(BL(1,Blt6_YuyukoF3))
	.db	LOW(BL(1,Blt6_YuyukoF2))
.hi:
	.db	HIGH(BL(1,Blt6_YuyukoF4))
	.db	HIGH(BL(1,Blt6_YuyukoF3))
	.db	HIGH(BL(1,Blt6_YuyukoF2))

St6_EnYuyukoS:

.1:
	ldy	<EN_BOSS_INX
	lda	EN_Y,y
	sta	EN_Y,x

	jsr	Rand
	and	#$1f
	clc
	adc	#$08
	eor	#$ff
	sec
	adc	EN_X,y
	bmi	.2
	sta	EN_X,x

	jsr	Rand
	and	#3
	tay
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	ldy	<EN_BOSS_INX
	lda	EN_X,y
	sta	EN_X,x

.2:
	lda	#10
	jsr	Enemy_CB_Wait

	ldy	<EN_BOSS_INX
	lda	EN_Y,y
	sta	EN_Y,x

	jsr	Rand
	and	#$1f
	clc
	adc	#$08
	clc
	adc	EN_X,y
	bmi	.3
	sta	EN_X,x

	jsr	Rand
	and	#3
	tay
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	ldy	<EN_BOSS_INX
	lda	EN_X,y
	sta	EN_X,x

.3:
	lda	#10
	jsr	Enemy_CB_Wait

	lda	<EVS_SPELL
	cmp	<EN_ST6_YOUMU_SPELL
	beq	.1
.9:
	lda	#$ff
	sta	EN_X,x
	rts
.lo:
	.db	LOW(BL(1,Blt6_YuyukoH8))
	.db	LOW(BL(1,Blt6_YuyukoH8))
	.db	LOW(BL(1,Blt6_YuyukoH9))
	.db	LOW(BL(1,Blt6_YuyukoH10))
.hi:
	.db	HIGH(BL(1,Blt6_YuyukoH8))
	.db	HIGH(BL(1,Blt6_YuyukoH8))
	.db	HIGH(BL(1,Blt6_YuyukoH9))
	.db	HIGH(BL(1,Blt6_YuyukoH10))

; eۊ֌W

St6_Shot_HookPlayerShot:
	lda	#LOW(St6_Shot_Hitcheck)
	sta	FN_SH_UPD
	lda	#HIGH(St6_Shot_Hitcheck)
	sta	FN_SH_UPD+1
	rts

St6_Shot_UnhookPlayerShot:
	lda	#LOW(PLC_SH_UPDATE)
	sta	FN_SH_UPD
	lda	#HIGH(PLC_SH_UPDATE)
	sta	FN_SH_UPD+1
	rts

St6_Shot_Hitcheck:
	lda	<EN_ST6_YUYUKO_SCREEN
	bne	.9
	bit	<BGS_STAT
	bmi	.9
	ldy	<EN_BOSS_INX
	lda	EN_S,y
	and	#$40
	bne	.9
	lda	SH_Y,x
	sec
	sbc	#8
	bmi	.9
	cmp	EN_Y,y
	bcs	.9
	lda	SH_X,x
	sec
	sbc	EN_Y,y
	sec
	sbc	#$20
	cmp	#$c0
	bcc	.9
	ror	SH_X,x
	lda	SH_D,x
	and	#$7f
	lsr	a
	eor	#$ff
	sec
	adc	EN_LIFE,y
	sta	EN_LIFE,y
.9:
	jmp	PLC_SH_UPDATE

St6_Shot_BG_Update:
	lda	SH_T,x
	and	#$10
	beq	.3

	ldy	SH_D,x
	lda	EN_STx_X,y
	bpl	.1
	lda	#$ff
	sta	SH_X,x
	rts
.1:
	txa
	sta	EN_STx_INX,y
	lda	EN_STx_UPD,y
	beq	.3

	lda	#0
	sta	EN_STx_UPD,y

	lda	SH_U,x
	clc
	adc	SH_DU,x
	sta	SH_U,x
	lda	EN_STx_X,y
	adc	SH_DX,x
	sta	EN_STx_X,y

	lda	SH_V,x
	clc
	adc	SH_DV,x
	sta	SH_V,x
	lda	EN_STx_Y,y
	adc	SH_DY,x
	sta	EN_STx_Y,y
	cmp	#$c0
	bcc	.2
	sta	EN_STx_X,y
.2:
	lda	EN_STx_X,y
	bpl	.3
	sta	SH_X,x
.3:
	lda	SH_Y,x
	jmp	_Shot_Plain_Update2

St6_ShCbSpiritA:
	lda	SH_A,x
	sta	<FNC_WORK+8

	jsr	Rand
	and	#7
	cmp	#4
	bcc	.1
	ora	#$f8
.1:
	adc	SH_A,x
	sta	SH_A,x

	lda	#LOW(BL(1,Blt6_SpiritB))
	ldy	#HIGH(BL(1,Blt6_SpiritB))
	jsr	SMCL(Shot_Normal_Create)

	lda	<FNC_WORK+8
	sta	SH_A,x

	; ҂
	lda	#2
	jsr	Shot_CB_Wait

	jsr	Rand
	and	#7
	cmp	#4
	bcc	.2
	ora	#$f8
.2:
	adc	SH_A,x
	sta	SH_A,x

	lda	#LOW(BL(1,Blt6_SpiritB))
	ldy	#HIGH(BL(1,Blt6_SpiritB))
	jsr	SMCL(Shot_Normal_Create)

	sec
	ror	SH_X,x

	rts

St6_ShCbSpiritD:
	lda	#5
	sta	SH_D,x
.1:
	lda	SH_A,x
	sta	<FNC_WORK+8

	jsr	Rand
	and	#$07
	tay
	lda	.angle,y
	clc
	adc	<FNC_WORK+8
	sta	SH_A,x

	txa
	and	#$02
	bne	.2

	lda	#LOW(BL(1,Blt6_SpiritE1))
	ldy	#HIGH(BL(1,Blt6_SpiritE1))
	bne	.3	; same as jmp
.2:
	lda	#LOW(BL(1,Blt6_SpiritE2))
	ldy	#HIGH(BL(1,Blt6_SpiritE2))
.3:
	jsr	SMCL(Shot_Normal_Create)

	lda	<FNC_WORK+8
	sta	SH_A,x

	; ҂
	lda	#3
	jsr	Shot_CB_Wait

	dec	SH_D,x
	bpl	.1

	sec
	ror	SH_X,x

	rts
.angle;
	.db	$fc,$fe,$fe,$00,$00,$02,$02,$04

St6_ShCbSpiritE:
	lda	#$14
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St6_ShCbSpiritF:
	inc	<EVS_A
	lda	<EVS_A
	and	#$01
	tay
	bne	.1
	lda	#$64
	bne	.2
.1:
	lda	#$a4
;	lda	#$ac
.2:
	clc
	adc	SH_A,x
	and	#$f8
	sta	SH_A,x

	tya
	ora	#8
.3:
	sta	SH_D,x
	and	#$01
	bne	.4

	lda	SH_A,x
	sec
	sbc	#$28
	sta	SH_A,x

	lda	#LOW(BL(1,Blt6_SpiritG1))
	ldy	#HIGH(BL(1,Blt6_SpiritG1))
	bne	.5	; same as jmp
.4:
	lda	SH_A,x
	clc
	adc	#$20
	sta	SH_A,x

	lda	#LOW(BL(1,Blt6_SpiritG2))
	ldy	#HIGH(BL(1,Blt6_SpiritG2))
.5:
	jsr	SMCL(Shot_Normal_Create)

	; ҂
	lda	#1
	jsr	Shot_CB_Wait

	lda	SH_D,x
	sec
	sbc	#2
	bpl	.3

	sec
	ror	SH_X,x

	rts

St6_ShCbSpiritG:
	lda	SH_A,x
	sec
	sbc	#$68
	bpl	.1
	eor	#$ff
.1:
	cmp	#$40
	bcc	.2
	eor	#$7f
.2:
	lsr	a
	lsr	a
	lsr	a
	sta	SH_D,x
	tay
	lda	.speed,y
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#3
	jsr	Shot_CB_Wait

	lda	#$14
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.speed:
	.db	$10,$16,$1c,$22,$28,$2e,$34,$3a,$40


St6_ShCbAggFairyB1:
	lda	#$e8
	bne	_St6_ShCbAggFairyB
St6_ShCbAggFairyB2:
	lda	#$18
_St6_ShCbAggFairyB:
	adc	SH_A,x
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St6_ShCbYoumuA1:
	lda	#40
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity
	asl	SH_DU,x
	rol	SH_DX,x
	asl	SH_DV,x
	rol	SH_DY,x

	lda	#126
	sta	SH_X,x
	lda	#88
	sta	SH_Y,x
	lda	#0
	sta	SH_U,x
	sta	SH_V,x

	lda	SH_A,x
	clc
	adc	#$50
	sta	SH_A,x

	lda	#4
	sta	SH_IS,x
.1:
	; ҂
	lda	#2
	jsr	Shot_CB_Wait

	lda	#LOW(BL(1,Blt6_YoumuA2))
	ldy	#HIGH(BL(1,Blt6_YoumuA2))
	jsr	SMCL(Shot_Normal_Create)

	dec	SH_IS,x
	bpl	.1

	sec
	ror	SH_X,x
	rts

St6_ShCbYoumuA2:

	lda	#2
	sta	SH_IS,x

	lda	SH_A,x
	clc
	adc	#$40
	bpl	.2
.1:
	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	lda	#LOW(BL(1,Blt6_YoumuA3))
	ldy	#HIGH(BL(1,Blt6_YoumuA3))
	jsr	SMCL(Shot_Normal_Create)

	dec	SH_IS,x
	bpl	.1
	bmi	.3	; same as jmp
.2:
	; ҂
	lda	#1
	jsr	Shot_CB_Wait

	lda	#LOW(BL(1,Blt6_YoumuA4))
	ldy	#HIGH(BL(1,Blt6_YoumuA4))
	jsr	SMCL(Shot_Normal_Create)

	dec	SH_IS,x
	bpl	.2
.3:
	sec
	ror	SH_X,x
	rts

St6_ShCbYoumuA3:
	ldy	SH_SP,x
	tya
	sta	SH_D,x
	lda	.speed1,y
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#12
	jsr	Shot_CB_Wait

	ldy	SH_D,x
	lda	.speed2,y
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.speed1:
	.db	12,18,24,30,36,42,48
.speed2:
	.db	26,25,24,23,22,21,20

St6_ShCbYoumuC1:
	lda	#192
	ldy	SH_A,x
	jsr	Util_GetRadius
	clc
	lda	SH_U,x
	adc	<FNC_ARG+2
	sta	SH_U,x
	lda	SH_X,x
	adc	<FNC_ARG
	sta	SH_X,x
	clc
	lda	SH_V,x
	adc	<FNC_ARG+3
	sta	SH_V,x
	lda	SH_Y,x
	adc	<FNC_ARG+1
	sta	SH_Y,x

	ldy	SH_T,x
	lda	Xcn,y
	and	#$01
	tay

	clc
	lda	SH_A,x
	adc	.angle,y
	sta	SH_A,x
	tay
	lda	#$0c
	jsr	Shot_SetVelocity

	lda	#$0a
	sta	SH_SP,x

	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	dec	SH_SP,x
	bne	.1
	sec
	ror	SH_X,x
	rts
.1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#03
	sta	<FNC_WORK+3
	lsr	a
	lda	SH_SP,x
	rol	a
	tay
;	clc
	lda	SH_A,x
	adc	.ia,y
	sta	<FNC_WORK+8

	jsr	Shot_GetPlayerAngle
	and	#$f0
	sta	SH_A,x

	ldy	<FNC_WORK+3
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	<FNC_WORK+8
	sta	SH_A,x
	tay
	lda	#$0c
	jsr	Shot_SetVelocity

	lda	#4
	sta	SH_FC,x

	rts
.angle:
	.db	$c0, $40
.ia:
	.db	$14,$ec,$10,$f0,$08,$f8,$fc,$04
	.db	$f0,$10,$e8,$18,$e0,$20,$f0,$10
	.db	$f8,$08,$fc,$04
.blt_lo:
	.db	LOW(BL(1,Blt6_YoumuC3))
	.db	LOW(BL(1,Blt6_YoumuC4))
	.db	LOW(BL(1,Blt6_YoumuC5))
	.db	LOW(BL(1,Blt6_YoumuC6))
.blt_hi:
	.db	HIGH(BL(1,Blt6_YoumuC3))
	.db	HIGH(BL(1,Blt6_YoumuC4))
	.db	HIGH(BL(1,Blt6_YoumuC5))
	.db	HIGH(BL(1,Blt6_YoumuC6))

St6_ShCbYoumuC3:
	lda	SH_SP,x
	beq	.1
	jmp	.10
.1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#01
	sta	<EN_ST6_YOUMU_CNT

	lda	#13
	sta	SH_SP,x

	jsr	Shot_GetPlayerAngle
	cmp	#$70
	bcs	.3
	lda	#$70
.3:
	cmp	#$90
	bcc	.4
	lda	#$90
.4:
	ldy	<EN_ST6_YOUMU_CNT
	bne	.5
	sec
	sbc	#$40
	bne	.6	; same as jmp
.5:
	clc
	adc	#$40
.6:
	tay
	lda	#48
	jsr	Util_GetRadius

	lda	<FNC_ARG+2
	sta	<EN_ST6_YOUMU_U
	ldy	<FNC_ARG
	sty	<EN_ST6_YOUMU_X
	asl	<FNC_ARG+2
	rol	<FNC_ARG
	clc
	adc	<FNC_ARG+2
	sta	<FNC_ARG+2
	tya
	adc	<FNC_ARG
	asl	<FNC_ARG+2
	rol	a
	clc
	adc	#64
	sta	SH_X,x
	lda	<FNC_ARG+2
	sta	SH_U,x

	lda	<FNC_ARG+3
	sta	<EN_ST6_YOUMU_V
	ldy	<FNC_ARG+1
	sty	<EN_ST6_YOUMU_Y
	asl	<FNC_ARG+3
	rol	<FNC_ARG+1
	clc
	adc	<FNC_ARG+3
	sta	<FNC_ARG+3
	tya
	adc	<FNC_ARG+1
	asl	<FNC_ARG+3
	rol	a
	clc
	adc	#48
	sta	SH_Y,x
	lda	<FNC_ARG+3
	sta	SH_V,x

.10:
	ldy	<EN_ST6_YOUMU_CNT
	lda	.next,y
	sta	<EN_ST6_YOUMU_CNT
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	SH_U,x
	sec
	sbc	<EN_ST6_YOUMU_U
	sta	SH_U,x
	lda	SH_X,x
	sbc	<EN_ST6_YOUMU_X
	sta	SH_X,x

	lda	SH_V,x
	sec
	sbc	<EN_ST6_YOUMU_V
	sta	SH_V,x
	lda	SH_Y,x
	sbc	<EN_ST6_YOUMU_Y
	sta	SH_Y,x

	ldy	EN_ST6_YOUMU_CNT
	iny

	dec	SH_SP,x
	bne	.11
	sec
	ror	SH_X,x
.11:
	lda	#1
	sta	SH_FC,x

	rts
.blt_lo:
	.db	LOW(BL(1,Blt6_YoumuC12))
	.db	LOW(BL(1,Blt6_YoumuC15))
	.db	LOW(BL(1,Blt6_YoumuC13))
	.db	LOW(BL(1,Blt6_YoumuC16))
	.db	LOW(BL(1,Blt6_YoumuC14))
	.db	LOW(BL(1,Blt6_YoumuC17))
.blt_hi:
	.db	HIGH(BL(1,Blt6_YoumuC12))
	.db	HIGH(BL(1,Blt6_YoumuC15))
	.db	HIGH(BL(1,Blt6_YoumuC13))
	.db	HIGH(BL(1,Blt6_YoumuC16))
	.db	HIGH(BL(1,Blt6_YoumuC14))
	.db	HIGH(BL(1,Blt6_YoumuC17))
.next:
	.db	2,3,4,5,0,1

St6_ShCbYoumuD:
	ldy	#11
.1:
	lda	EN_STx_X,y
	bmi	.2
	dey
	bpl	.1
	lda	#$ff
	sta	SH_X,x
	rts
.2:
	txa
	sta	EN_STx_INX,y
	tya
	sta	SH_D,x
	lda	SH_X,x
	sta	EN_STx_X,y
	sta	EN_STx_X2,y
	lda	SH_Y,x
	sta	EN_STx_Y,y
	sta	EN_STx_Y2,y
	lda	SH_T,x
	ora	#$10
	sta	SH_T,x
	lda	#0
	sta	EN_STx_UPD,y
	rts

St6_ShCbYoumuE:
	jsr	Rand
	cmp	#$70
	bcc	.2
	cmp	#$90
	bcs	.1
	eor	#$80
.1:
	clc
.2:
	adc	SH_A,x
	sta	SH_A,x
	and	#$03
	asl	a
	clc
	adc	#16
	sta	SH_SP,x

	lda	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	lda	#2
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#$f8
	sta	SH_IS,x

	; ҂
	lda	#4
	jsr	Shot_CB_Wait

	lda	#2
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#$02
	sta	SH_IS,x

	; ҂
	lda	#8
	jsr	Shot_CB_Wait

	lda	#6
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#$01
	sta	SH_IS,x

	rts

St6_ShCbYoumuF1:
	ldy	SH_SP,x
	tya
	sta	SH_D,x
	lda	.sp1,y
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	; ҂
	lda	#8
	jsr	Shot_CB_Wait

	ldy	SH_D,x
	lda	.sp2,y
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.sp1:
	.db	18,24,30,36
.sp2:
	.db	17,16,15,14

St6_ShCbYoumuF2:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	.sp,y
	sta	SH_SP,x

	jsr	Shot_GetPlayerAngle
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.sp:
	.db	17,20,23

St6_ShCbYoumuH:
	lda	SH_NUM
	clc
	adc	SH_NUM+1
	cmp	#60
	bcc	.1
	ror	SH_X,x
	rts
.1:
	lda	#4
	sta	SH_FC,x
	rts

St6_ShCbYoumuI1:
	lda	#2
	sta	<FNC_WORK+8
	lda	SH_A,x
	sta	<FNC_WORK+9
.1:
	jsr	Rand
	sta	SH_A,x

	ldy	SH_IA,x
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	dec	<FNC_WORK+8
	bpl	.1

	lda	<FNC_WORK+9
	sta	SH_A,x

	dec	SH_IS,x
	beq	.3

	lda	#4
	sta	SH_FC,x
	rts
.3:
	lda	#$ff
	sta	SH_X,x
	rts
.blt_lo:
	.db	LOW(BL(1,Blt6_YoumuI2))
	.db	LOW(BL(1,Blt6_YoumuI3))
	.db	LOW(BL(1,Blt6_YoumuI4))
	.db	LOW(BL(1,Blt6_YoumuI5))
	.db	LOW(BL(1,Blt6_YoumuI6))
.blt_hi:
	.db	HIGH(BL(1,Blt6_YoumuI2))
	.db	HIGH(BL(1,Blt6_YoumuI3))
	.db	HIGH(BL(1,Blt6_YoumuI4))
	.db	HIGH(BL(1,Blt6_YoumuI5))
	.db	HIGH(BL(1,Blt6_YoumuI6))

St6_ShCbYoumuI2:
	jsr	Rand
	and	#$07
	cmp	#$04
	bcc	.1
	ora	#$f8
.1:
	sta	SH_IA,x

	lda	#4
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#2
	sta	SH_IS,x
	lda	#8
	sta	SH_SP,x
	rts

St6_ShCbYuyukoC1:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcc	.1
	ror	SH_X,x
.1:
	rts

St6_ShCbYuyukoC2:
	jsr	Shot_GetPlayerAngle
	sta	SH_A,x
	tay
	lda	SH_SP,x
	jmp	Shot_SetVelocity

St6_ShCbYuyukoD1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	.xpos,y
	sta	SH_X,x

	cpy	#$02
	ldy	<EVS_D
	lda	.pat,y
	bcc	.1
	lsr	a
	lsr	a
.1:
	and	#$03
	beq	.9
	tay

	lda	.cnt-1,y
	sta	SH_IS,x

	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	cmp	#$80
	lda	#$04
	bcc	.2
	lda	#$fc
.2:
	sta	SH_IA,x

	lda	#LOW(St6_ShCbYuyukoD2)
	sta	SH_CB,x
	lda	#HIGH(St6_ShCbYuyukoD2)
	sta	SH_CB+1,x
	lda	#10
	sta	SH_FC,x
.9:
	lda	#$10
	sta	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity
.xpos:
	.db	48,80,24,104
.cnt:
	.db	4, 6, 8
.pat:
	.db	$05, $05, $0a, $0a, $0d, $0d, $08, $08
	.db	$05, $05, $02, $02, $05, $05, $08, $08
	.db	$0d, $0d, $0a, $0a, $05, $05, $00, $00

St6_ShCbYuyukoD2:
	dec	SH_IS,x
	bne	.1
	rts
.1:
	lda	#$04
	sta	SH_FC,x
	lda	SH_A,x
	clc
	adc	SH_IA,x
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St6_ShCbYuyukoE1:
	jsr	Rand
	and	#$1f
	sec
	sbc	#$10
	clc
	adc	SH_A,x
	sta	SH_A,x

	; ^[Qbgɐ
.1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	Bit,y
	ora	<EN_ST6_SHOT_SYNC
	sta	<EN_ST6_SHOT_SYNC

	lda	#2
	jsr	Shot_CB_Wait

	ldy	SH_T,x
	lda	Xcn,y
	and	#$01
	sta	<FNC_WORK+3

	lda	SH_X,x
	sta	<FNC_ARG
	lda	SH_Y,x
	sta	<FNC_ARG+1
	lda	<EN_ST6_TARGET_X
	sta	<FNC_ARG+2
	lda	<EN_ST6_TARGET_Y
	sta	<FNC_ARG+3
	jsr	Util_GetAngle

	ldy	<FNC_WORK+3
	sta	<FNC_WORK+2
	sec
	sbc	SH_A,x
	bmi	.2
	cmp	.limit,y
	bcc	.3
	lda	.limit,y
	bne	.3	; same as jmp
.2:
	cmp	.limit+2,y
	bcs	.3
	lda	.limit+2,y
.3:
	clc
	adc	SH_A,x
	sta	SH_A,x
	tay

	dec	SH_SP,x
	lda	SH_SP,x
	cmp	#6
	bcs	.4
	lda	<FNC_WORK+2
	sta	SH_A,x
	lda	#6
.4:
	jsr	Shot_SetVelocity

	lda	SH_A,x
	cmp	<FNC_WORK+2
	bne	.1
	beq	.7	; same as jmp

	; ^[Qbgʒu܂ňړ
.5:
	lda	SH_SP,x
	cmp	#24
	bcs	.6
	inc	SH_SP,x
	inc	SH_SP,x
.6:
	jsr	Shot_SetVelocity

	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	Bit,y
	ora	<EN_ST6_SHOT_SYNC
	sta	<EN_ST6_SHOT_SYNC

	lda	#2
	jsr	Shot_CB_Wait
.7:
	lda	<EN_ST6_TARGET_X
	sta	<FNC_ARG+2
	lda	<EN_ST6_TARGET_Y
	sta	<FNC_ARG+3
	lda	SH_X,x
	ldy	SH_Y,x
	cmp	<FNC_ARG+2
	bne	.8
	cpy	<FNC_ARG+3
	beq	.9
.8:
	sta	<FNC_ARG
	sty	<FNC_ARG+1
	jsr	Util_GetAngle
	tay

	lda	<FNC_ARG+4
	ora	<FNC_ARG+5
	cmp	#8
	bcs	.5

	lda	<FNC_ARG+2
	sta	SH_X,x
	lda	<FNC_ARG+3
	sta	SH_Y,x
.9:
	lda	#$00
	sta	SH_U,x
	sta	SH_V,x
	sta	SH_DX,x
	sta	SH_DY,x
	sta	SH_DU,x
	sta	SH_DV,x

	lda	#2
	jsr	Shot_CB_Wait

	lda	#$ff
	sta	SH_X,x
	rts
.limit:
	.db	$0c, $24
	.db	$f4, $dc

St6_ShCbYuyukoE2:
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoE4:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$40
	bpl	.1
	sta	SH_X,x
.1:
	rts

St6_ShCbYuyukoF1:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcc	.1
	ror	SH_X,x
.1:
	rts

St6_ShCbYuyukoF3:
	lda	SH_X,x
	cmp	<PL_X
	sta	<FNC_ARG
	lda	SH_Y,x
	sta	<FNC_ARG+1
	lda	#$20
	bcc	.1
	eor	#$ff
.1:
	adc	<PL_X
	bpl	.2
	cmp	#$c0
	lda	#$ff
	adc	#$00
	and	#$7f
.2:
	sta	<FNC_ARG+2
	lda	<PL_Y
	sta	<FNC_ARG+3
	jsr	Util_GetAngle
	jmp	_St6_ShCbYuyukoF2

St6_ShCbYuyukoF2:
	jsr	Shot_GetPlayerAngle
_St6_ShCbYuyukoF2:
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	lda	#03
	sta	SH_IS,x

	lda	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	lda	#12
	jsr	Shot_CB_Wait

	lda	#00
	sta	SH_VC,x
	sta	SH_VN,x
	sta	SH_IS,x
	rts

St6_ShCbYuyukoG1:
	lda	SH_A,x
	sec
	sbc	#$40
	bmi	.1
	lda	#LOW(BL(1,Blt6_YuyukoG8))
	ldy	#HIGH(BL(1,Blt6_YuyukoG8))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoG2:
	lda	SH_A,x
	sec
	sbc	#$40
	bmi	.1
	lda	#LOW(BL(1,Blt6_YuyukoG9))
	ldy	#HIGH(BL(1,Blt6_YuyukoG9))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoG3:
	lda	#LOW(BL(1,Blt6_YuyukoG10))
	ldy	#HIGH(BL(1,Blt6_YuyukoG10))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoG4:
	lda	#LOW(BL(1,Blt6_YuyukoG11))
	ldy	#HIGH(BL(1,Blt6_YuyukoG11))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoH1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	.angle,y
	clc
	adc	SH_A,x
	sta	SH_A,x
	lda	#LOW(BL(1,Blt6_YuyukoH4))
	ldy	#HIGH(BL(1,Blt6_YuyukoH4))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts
.angle:
	.db	$fd, $00, $03, $06

St6_ShCbYuyukoH2:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	.angle,y
	clc
	adc	SH_A,x
	sta	SH_A,x
	lda	#LOW(BL(1,Blt6_YuyukoH5))
	ldy	#HIGH(BL(1,Blt6_YuyukoH5))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts
.angle:
	.db	$03, $00, $fd, $fa

St6_ShCbYuyukoH3:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcs	.1
	lda	#LOW(BL(1,Blt6_YuyukoH6))
	ldy	#HIGH(BL(1,Blt6_YuyukoH6))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoH4:
	jsr	Shot_GetPlayerAngle
	sec
	sbc	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcs	.1
	lda	#LOW(BL(1,Blt6_YuyukoH7))
	ldy	#HIGH(BL(1,Blt6_YuyukoH7))
	jsr	SMCL(Shot_Normal_Create)
.1:
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoK1:
	lda	#LOW(BL(1,Blt6_YuyukoK2))
	ldy	#HIGH(BL(1,Blt6_YuyukoK2))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoK2:
	lda	#LOW(BL(1,Blt6_YuyukoK3))
	ldy	#HIGH(BL(1,Blt6_YuyukoK3))
	jsr	SMCL(Shot_Normal_Create)
	lda	#$ff
	sta	SH_X,x
	rts

St6_ShCbYuyukoK3:
	lda	SH_SP,x
	clc
	adc	<EVS_D
	sta	SH_SP,x

	lda	#14
	jsr	Shot_CB_Wait

	lda	#00
	sta	SH_VC,x
	sta	SH_VN,x
	sta	SH_IS,x
	rts

; [eBeB

St6_Util_CutIn:
	lda	<VCMD_SIZE
	cmp	#48
	bcs	.1
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB
	sty	<FNC_WORK+11
	ldy	<EVS_A
	inc	<EVS_A
	lda	.lo,y
	ldx	.hi,y
	jsr	Vcmd_SequenceData
	ldy	<FNC_WORK+11
	rts
.1:
	pla
	pla
	lda	#0
	rts
.lo:
	.db	LOW(Vcmd_CutIn1a)
	.db	LOW(Vcmd_CutIn1b)
	.db	LOW(Vcmd_CutIn1c)
	.db	LOW(Vcmd_CutIn1d)
	.db	LOW(Vcmd_CutIn1e)
	.db	LOW(Vcmd_CutIn1f)
	.db	LOW(Vcmd_CutIn1g)
	.db	LOW(Vcmd_CutIn1h)
.hi:
	.db	HIGH(Vcmd_CutIn1a)
	.db	HIGH(Vcmd_CutIn1b)
	.db	HIGH(Vcmd_CutIn1c)
	.db	HIGH(Vcmd_CutIn1d)
	.db	HIGH(Vcmd_CutIn1e)
	.db	HIGH(Vcmd_CutIn1f)
	.db	HIGH(Vcmd_CutIn1g)
	.db	HIGH(Vcmd_CutIn1h)

